require 'listen'

class FileWatcher
  def initialize(path)
    @path = path
    @listener = nil
  end

  def startWatcher
    if File.directory?(@path) == false
      @path = File.dirname(@path)
      if File.directory?(@path)
        puts "watcher path not exist: #{@path}"
        return
      end
    end

    @listener = Listen.to(@path, only: onlyReg) do |modified, added, removed|
      modified.each { |path| path.force_encoding('utf-8') }
      yield(modified) unless modified.empty?
      # added.each { |path| path.force_encoding('utf-8') }
      # removed.each { |path| path.force_encoding('utf-8') }
    end

    @listener.start
    sleep
  end

  def onlyReg
    /\.m$/
  end

end